package {
	import fl.controls.*;
	
	import flash.display.Sprite;
	import flash.events.Event;
	
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.objects.OldCube;
	import org.papervision3d.scenes.Scene3D;

	public class BoxSample extends Sprite
	{
		private var container:Sprite;
		private var scene:Scene3D;
		private var camera:Camera3D;
		
		public var cb:CheckBox;
		
		public function BoxSample()
		{
			this.init();
			this.createChildren();
			
			this.addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}
		private function init():void {
			this.container = new Sprite();
			this.container.x = this.stage.stageWidth/2;
			this.container.y = this.stage.stageHeight/2;
			this.addChild(this.container);
			
			this.scene = new Scene3D(this.container);
			
			this.camera = new Camera3D(null, 10);
			this.camera.x = 330;
			this.camera.y = 335;
		}
		private function createChildren():void {
			var cube1:OldCube = new OldCube(new WireframeMaterial(0x333333), 200, 105, 75);
			this.scene.addChild(cube1);
			
			var cube2:OldCube = new OldCube(new WireframeMaterial(0x333333), 200, 164, 57);
			cube2.x = -30;
			cube2.y = -66;
			this.scene.addChild(cube2);
		}
		private function onEnterFrame(e:Event):void {
			if(this.cb.selected){
				this.camera.x = this.container.mouseX*5;
				this.camera.y = -this.container.mouseY*5;
			}
			
			this.scene.renderCamera(this.camera);
		}
	}
}
